function [ val, new_list ] = choose_from_list( list )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Select a random element from a list
% and return that element and list with it removedt

list_len = length( list );

index = floor( rand*list_len )+1;
val = list( index );

if index == 1
  new_list = list( 2:list_len );
elseif index == list_len
  new_list = list( 1:list_len-1 );
else
  new_list = [ list( 1:index-1 ) list( index+1:length( list ) ) ];
end