function x = get_bad_phi( f, h, n ) 

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  disp( 'BAD PHI VALUE FOUND!' );
  disp( [ n, f, h ] );

  % Since it didn't work, probably either a large positive value
  % or a large negative value is the closest. Which should be obvious.
  % (THIS IS NEW.  IS THIS THE RIGHT THING TO DO?)
  big_phi = 1000;
  x = big_phi;

  pos_dif = sum( abs( get_P( f, h, big_phi ) - (n/sum(n)) ) );
  neg_dif = sum( abs( get_P( f, h, -1*big_phi ) - (n/sum(n)) ) );
  if pos_dif < neg_dif
    disp( 'Setting phi to BIG PHI');
  else
    disp( 'Setting phi to SMALL PHI' );
    x = -1*x;
  end